  

DynamicLinkLibrary variableByteSubclass: #TkbVmErrorTrackingDLL
  classVariableNames: 'EnableExceptionHandler '
  poolDictionaries: ''!
 
TkbVmErrorTrackingDLL class instanceVariableNames: ''!


!TkbVmErrorTrackingDLL class methods !
  
startup

    " If this exception handler is installed, the DLL may not be unloaded until
    the image terminates. Otherwise you may get nested exceptions. "

    | dll |

    EnableExceptionHandler ~= false ifTrue: [
        [dll := self current] on: Error do: [ :e | nil ].
        dll notNil ifTrue: [
            dll walkExceptionFrames.]].!

shutdown

    " If you call this, make sure this image quits in the next view milliseconds.
    The VM exception handler chain will contain pointers to unmapped memory
    and any further exception will cause havoc. "

    self currentOrNil notNil ifTrue: [
        self currentOrNil close.].

!

enableExceptionHandler: aBool

    " Control the behavior of the new VM exception handler. If you change this
    setting, you need to quit and restart your image to make it work. "

    EnableExceptionHandler := aBool.!
   
fileName

    ^'vmerrtr.dll'! !


!TkbVmErrorTrackingDLL methods !
 
writeStackDump

    <api: WriteStackDump none>
    ^self invalidArgument!

walkExceptionFrames

    <api: WalkExeptionFrames none>
    ^self invalidArgument
! !
